/*
  common_gethtml.cpp - Implementation of Common::GetHTML.

  Jason Hood, 5 August, 2009.
*/

#include "common.h"


// Retrieve an HTML (XML/RDL) resource, returning a pointer to it and storing
// its length in LEN.  If the resource does not exist, returns NULL and LEN is
// set to 0.  If the resource starts with the BOM, don't include it.
LPCWSTR Common::GetHTML( UINT id, int& len )
{
  LPCWSTR mem = NULL;
  len = 0;

  int dll = id >> 16;
  if (dll < resmod.size())
  {
    HMODULE mod = resmod[dll];
    if (mod)
    {
      HRSRC rsrc = FindResourceEx( mod, RT_HTML,
				   MAKEINTRESOURCE( id & 0xffff ), 0 );
      if (rsrc)
      {
	HGLOBAL res = LoadResource( mod, rsrc );
	if (res)
	{
	  mem = (LPCWSTR)LockResource( res );
	  if (mem)
	  {
	    len = SizeofResource( mod, rsrc ) >> 1;
	    if (*mem == 0xFEFF)
	    {
	      ++mem;
	      --len;
	    }
	  }
	}
      }
    }
  }

  return mem;
}
