/*
  common_getresdll.cpp - Implentation of Common::get_resdll.

  Jason Hood, 10 August, 2009.
*/

#include "common.h"


// Return the file and its resource number associated with Freelancer's ID.
// Returns NULL if ID exceeds the number of DLLs referenced, but does not
// detect if the DLL was actually loaded, or the resource actually exists.
LPCSTR Common::get_resdll( UINT id, UINT& rid )
{
  int res = id >> 16;
  if (res >= resdll.size())
    return NULL;

  rid = id & 0xffff;
  return resdll[res].c_str();
}
