/*
  common_getstring.cpp - Implementation of Common::GetString.

  Jason Hood, 5 August, 2009.
*/

#include "common.h"


// Retrieve a string resource, copying at most MAX-1 characters to BUF and
// returning the length of the string.	If all_strings is false and the string
// is just a single space, pretend the string is empty.
int Common::GetString( UINT id, LPSTR buf, int max, bool all_strings )
{
  *buf = '\0';
  int len = 0;

  int dll = id >> 16;
  if (dll < resmod.size())
  {
    HINSTANCE inst = resmod[dll];
    if (inst)
    {
      len = LoadString( inst, id & 0xffff, buf, max );
      if (!all_strings && len == 1 && *buf == ' ')
      {
	*buf = '\0';
	len = 0;
      }
    }
  }

  return len;
}
