/*
  common_getstring2.cpp - Implementation of Common::GetString (two parameters).

  Jason Hood, 11 August, 2009.
*/

#include "common.h"


// Retrieve a string resource, returning a pointer to it and storing its length
// in LEN.  If the resource does not exist, returns NULL and LEN is set to 0.
LPCWSTR Common::GetString( UINT id, int& len )
{
  LPCWSTR mem = NULL;
  len = 0;

  int dll = id >> 16;
  if (dll < resmod.size())
  {
    HMODULE mod = resmod[dll];
    if (mod)
    {
      UINT grp = ((id & 0xffff) >> 4) + 1;
      HRSRC rsrc = FindResourceEx( mod, RT_STRING, MAKEINTRESOURCE( grp ), 0 );
      if (rsrc)
      {
	HGLOBAL res = LoadResource( mod, rsrc );
	if (res)
	{
	  mem = (LPCWSTR)LockResource( res );
	  if (mem)
	  {
	    for (id &= 0x0f;; --id)
	    {
	      len = *mem;
	      if (id == 0)
		break;
	      mem += len + 1;
	    }
	    if (len == 0)
	      mem = NULL;
	    else
	      ++mem;
	  }
	}
      }
    }
  }

  return mem;
}
