/*
  hashdb.h - Header file for the hash database.

  Jason Hood, 5 August, 2009.
*/

#ifndef _HASHDB_H
#define _HASHDB_H

#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include <map>

typedef std::pair<LPCSTR, LPCSTR> NickName;
typedef std::map<UINT, NickName>  HashMap;
typedef HashMap::const_iterator   HashMapCIter;

class HashDB
{
public:
  bool	 open( LPCSTR, bool = false );
  void	 close();
  void	 save() { temp = fnd; }
  void	 load() { fnd = temp; }
  bool	 find( UINT id ) { return ((fnd = hashes.find( id )) != hashes.end()); }
  bool	 search( int, char* [], int, bool );
  UINT	 id()	const { return fnd->first; }
  LPCSTR nick() const { return fnd->second.first; }
  LPCSTR name() const { return fnd->second.second; }

private:
  HANDLE file;
  HANDLE map;
  LPVOID view;
  HashMap hashes;
  HashMapCIter fnd, temp;
};

#endif
