/*
  hashdb_search.cpp - Implementation of HashDB::search.

  Jason Hood, 5 August, 2009.
*/

#include "hashdb.h"


// Determine if PAT (assumed lower case) exists within TGT.
static bool istrstr( LPCSTR tgt, LPCSTR pat )
{
  int delta = strlen( tgt ) - strlen( pat );
  if (delta < 0)
    return false;

  LPCSTR end = tgt + delta;
  for (;;)
  {
    while (*pat != tolower( *tgt ))
    {
      if (++tgt > end)
	return false;
    }
    for (int i = 1;; ++i)
    {
      if (pat[i] == '\0')
	return true;
      if (pat[i] != tolower( tgt[i] ))
	break;
    }
    ++tgt;
  }
}


bool HashDB::search( int patc, char* patv[], int flag, bool start )
{
  HashMapCIter end = hashes.end();

  if (start)
    fnd = hashes.begin();
  else
    ++fnd;
  if (fnd == end)
    return false;

  if (flag != 1)
  {
    while (*fnd->second.second == '\0')
    {
      if (++fnd == end)
	return false;
    }
  }

  if (patc == 0)
    return true;

  for (;;)
  {
    for (int i = patc; --i >= 0;)
    {
      if (istrstr( (flag) ? fnd->second.first : fnd->second.second, patv[i] ))
	return true;
    }
    if (++fnd == end)
      return false;
    if (flag != 1)
    {
      while (*fnd->second.second == '\0')
      {
	if (++fnd == end)
	  return false;
      }
    }
  }

  return false;
}
