/*
  output.cpp - Implementation of output.

  Jason Hood, 11 August, 2009 (after accidently deleting it).
*/

#include "common.h"


void output( UINT id, LPCSTR nickname, LPCSTR name, int fmt, int flags )
{
  if (!*name && (flags & outName))
    return;

  if (fmt == fmtIONCROSS)
  {
    if (flags & outName)
      printf( "%s = %s", nickname, name );
    else
      printf( "%10u = %s, %s", id, nickname, (*name) ? name : nickname );
  }
  else if (fmt == fmtMTR)
  {
    if (flags & outName)
      printf( "\"%s\" = \"%s\"\t# %10u", nickname, name, id );
    else
      printf( "%10u = \"%s\"", id, nickname );
    if (flags & outHex)
      printf( (flags & outName) ? "  %#10x" : "\t# %#10x", id );
    if (flags & outMinus)
      printf( (flags & (outName | outHex)) ? "  %11d" : "\t# %11d", id );
    if (*name && !(flags & outName))
      printf( (flags & (outHex | outMinus)) ? "  %s" : "\t# %s", name );
  }
  else
  {
    char  sep;
    char* str;
    if (fmt == fmtCSV)
    {
      sep = ',';
      str = "\"%s\"";
    }
    else
    {
      sep = '\t';
      str = "%s";
    }
    printf( "%10u%c", id, sep );
    if (flags & outHex)
      printf( "%#10x%c", id, sep );
    if (flags & outMinus)
      printf( "%11d%c", id, sep );
    printf( str, nickname );
    if (*name)
    {
      putchar( sep );
      printf( str, name );
    }
  }
  putchar( '\n' );
}
